#include <iostream.h>
   
class Converter {
protected:
  double val1;  // initial value
  double val2;  // Convertered value
public:
  Converter(double i) {
    val1 = i;
  }
  double getConvertedValue() { return val2; }
  double setValue() { return val1; }
   
  virtual void compute() = 0;
};
   
// Liters to gallons.
class LitreToGallon : public Converter {
public:
  LitreToGallon(double i) : Converter(i) { }
  void compute() {
    val2 = val1 / 3.7854;
  }
};
   
// Fahrenheit to Celsius
class FahrenheitToCelsius : public Converter {
public:
  FahrenheitToCelsius(double i) : Converter(i) { }
  void compute() {
    val2 = (val1-32) / 1.8;
  }
};
   
int main()
{
  Converter *p;  // pointer to base class
   
  LitreToGallon lgob(10);
  FahrenheitToCelsius fcob(100);
   
  // use virtual function mechanism to Converter
  p = &lgob;
  cout << p->setValue() << " liters is ";
  p->compute();
  cout << p->getConvertedValue() << " gallons\n";  
   
  p = &fcob;
  cout << p->setValue() << " in Fahrenheit is ";
  p->compute();
  cout << p->getConvertedValue() << " Celsius\n";  
    return 0;
}
